
#ifndef __LOAD_H__
#define __LOAD_H__

#include "param.h"
#include "shaunlib.h"

// ----------------------------------------------------------------------------------
// MAIN DATA VARIABLES
// ----------------------------------------------------------------------------------

class Data
{
 public:
  IntMatrix           d1;           // [ind][loc] allele 1
  IntMatrix           d2;           // [ind][loc] allele 2
  IntArray            ic;           // [individual] : which configuration they are in
  CMatrix             ph;           // [individual][phenotype] : phenotypes
  IntArray            fix2c;        // fix-to-class information if defined
  IntArray            fixconfig2c;
  StringArray         id;           // IDs

  int                 nInd;             // # individuals, calculated from file
  int                 nLoci;            // # loci, calculated from file

  void                load(Param &);
  void                process(Param &);
  void                hw_recode(Param &);

// ----------------------------------------------------------------------------------
// CODING SYSTEM VARIABLES
// ----------------------------------------------------------------------------------
  IntMatrix           s1;             // [ind][loc] allele 1
  IntMatrix           s2;             // [ind][loc] allele 2
  IntMatrix           c;              // reference table for alleles [locus] [code]
  IntMatrix           fallele;        // number of individual alleles of type X

  IntArray            nallele;        // number of alleles at locus
  IntArray            fconfig;        // number of individuals of configuiration X
  int                 nconfig;        // total number of configurations
  IntMatrix           config1;
  IntMatrix           config2;
};

#endif
