#ifndef __OUTPUT_H__
#define __OUTPUT_H__

#include "shaunlib.h"
#include "data.h"
#include "param.h"


class Output
{
 public:

  Output();
  Output(Param &, LCAParam &);
  ~Output();

  CVector n; 
  CMatrix h;    
  double ***r; 
  double ml ;
  int ii;

  int nLoci, nClass, nAllele;

  void basic(Param &p, LCAParam &lp, Data &d);
  void data(Param &p, Data &d);
  void estimates(Param &p, LCAParam &lp, Data &d);
  void minimal(Param &p, LCAParam &lp);

  void entropy(Param &p, LCAParam &lp, Data &d); 
  void locinfo(Param &p, LCAParam &lp, Data &d); 
  void cslocinfo(Param &p, LCAParam &lp, Data &d);
  void distance(Param &p, LCAParam &lp, Data &d);
};

#endif
